'$include: 'gslib.bi'
declare function shiftLeft%(BYVAL value, BYVAL numOfbits)
declare sub docircle(segment%, offset%, x%, y%, radius%, col%)
declare function retcol(x%, y%)
declare sub changeCol(col2change%, newR%, newG%, newB%)

defint a-z
rem $dynamic

type vect2D
	x as integer
	y as integer
end type

type particleSystem
	x as integer
	y as integer
	col as integer
	vel as vect2D
	acc as vect2D
end type

const particles=10

dim shared buffer(0 to 31999) as integer
dim shared blurBMP(0 to 31999) as integer
dim shared particle(particles) as particleSystem

	randomize timer
			x=int(rnd*318): y=int(rnd*198)

	for counter=0 to particles
			particle(counter).x=x
			particle(counter).y=y
			particle(counter).col=255
			particle(counter).vel.x=int(rnd*10)-5
			particle(counter).vel.y=int(rnd*10)-5
			particle(counter).acc.x=0
			particle(counter).acc.y=1
	next

screen 13
	GSinit
			
			for col=0 to 63
					changeCol col, col, 0, 0
					changeCol col+64, 63, col, 0
					changeCol col+128, 63, 63, col
					changeCol col+192, 63, 63, 63
			next

			GSsetBBox 0, 0, 318, 198
			sleep

	do
			for counter=0 to particles

					particle(counter).x=particle(counter).x+particle(counter).vel.x
					particle(counter).y=particle(counter).y+particle(counter).vel.y

					particle(counter).vel.x=particle(counter).vel.x+particle(counter).acc.x
					particle(counter).vel.y=particle(counter).vel.y+particle(counter).acc.y

					if particle(counter).x<0 or particle(counter).x>=318 then
								particle(counter).vel.x=particle(counter).vel.x-1
								particle(counter).vel.x=particle(counter).vel.x*-1
					end if

					if particle(counter).y<0 or particle(counter).y>=198 then
								particle(counter).vel.y=particle(counter).vel.y-1
								particle(counter).vel.y=particle(counter).vel.y*-1
					end if

					for radius=2 to 0 step -1
						docircle varSeg(buffer(0)), varPtr(buffer(0)), particle(counter).x, particle(counter).y, radius, particle(counter).col
					next

					particle(counter).col=particle(counter).col-1
						if particle(counter).col<0 then particle(counter).col=0
			next
			
			def seg=varSeg(buffer(0))+varPtr(buffer(0))

			for x=0 to 318
					for y=0 to 198
							col=(retcol(x-1, y)+retcol(x+1, y)+retcol(x, y-1)+retcol(x, y+1))
							col=col\4
							col=col-1
							if col<0 then col=0
							GSpset x, y, varSeg(blurBMP(0)), varPtr(blurBMP(0)), col
					next
			next
							
			def seg

			GSpCopy varSeg(blurBMP(0)), varPtr(blurBMP(0)), varSeg(buffer(0)), varPtr(buffer(0))
			GSpCopy varSeg(buffer(0)), varPtr(buffer(0)), &HA000, 0

	loop until inkey$=chr$(27)

end

defint a-z
rem $dynamic
sub docircle(segment, offset, x, y, radius, col)

for degree%=0 to 360
		vx%=cos(degree%)*radius
		vy%=sin(degree%)*radius
				GSpset x+vx, y+vy, segment, offset, col
next

end sub

defint a-z
rem $dynamic
function retcol(x, y)

tempY=shiftLeft(y, 8)
tempY=tempY+shiftLeft(y, 6)
retcol=peek(tempY+x)

end function

defint a-z
rem $dynamic
sub changeCol(col2change, newR, newG, newB)
out &H3C8, col2change
out &H3C9, newR
out &H3C9, newG
out &H3C9, newB
end sub
